import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:isolate';

import 'package:args/args.dart';
import 'package:logging/logging.dart';

import 'src/{{template1}}.dart';
import 'src/{{template2}}.dart';

var _log = Logger('dartrix');

void printUsage() {
  print("\n\t\tDartrix Template package: {{templatelib}}\n");
  print("Available templates:\n");
  print("\t{{template1}}");
  print("\t{{template2}}\n");
}

void main(List<String> args, SendPort sport) {

  Logger.root.level = Level.ALL;
  Logger.root..onRecord.listen((record) {
      print('${record.loggerName} ${record.level.name}: ${record.message}');
  });

  // First arg is always the template name. The following args will be
  // parsed by the template generator.
  switch(args[0]) {
    case "{{template1}}": generate{{template1}}(args, sport); break;
    case "{{template}}": generate{{template2}}(args, sport); break;
    case null:
    if (args.contains("--help") || args.contains("-h")) {
      printUsage();
    } else {
      print("{{template1}}: No template specified.");
    }
    break;
    default:
    print("No template for ${args[0]}.");
  }
}
