import 'dart:io';
import 'dart:isolate';

import 'package:logging/logging.dart';
import 'package:args/args.dart';

var _log = Logger('{{template1}}');

void generate{{Template1}}(List<String> args, SendPort dartrixPort) {
  _log.info("generate{{Template1}}");

  // Parse command-line args:
  var argParser = ArgParser();
  argParser.addOption('libname', abbr: 'l',
    valueHelp: "String",
    help: "Template library name, without _dartrix suffix.\nFor example, '-l foo_bar' will generate lib 'foo_bar_dartrix'.",
    defaultsTo: 'mytemplates',
  );
  argParser.addFlag('help', abbr: 'h', defaultsTo: false);
  argParser.addFlag('verbose', abbr: 'v', defaultsTo: false);

  ArgResults options = argParser.parse(args);

  if (options['help']) {
    print("{{templatelib}} template {{template1}}\n");
    print("Parameters:\n");
    print(argParser.usage);
    exit(0);
  }

  var mydata = {
    'salutation' : options['salutation'],
    'greeting': options['greeting'],
    'to': options['to'],
    'closing': options['closing'],
    'from': options['from'],
    'segmap' : {
      'LIB_DARTRIX' : options['libname']
    },
    // 'root' : 'my/r',
    // 'domain': 'foo.acme.org',
    // 'class' : 'Test',
    'description' : {
      '{{template1}}' : "A {{Template1}} World demo."
    },
    'dartrix': {'mergeData': true}
  };
  _log.info("sending template data back to dartrix");
  dartrixPort.send(mydata);
}

