import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:isolate';

import 'package:timeago/timeago.dart';

import 'package:args/args.dart';
import 'package:logging/logging.dart';
import 'package:resource/resource.dart';

import 'src/goodbye.dart';
import 'src/hello.dart';

var _log = Logger('dartrix');

SendPort dartrixPort;

String _resolvePkg(String pkg) {

}

void _generate(String template, Map data) async {
  _log.info("_generating files");

  String pkg = "package:hello_template/new.dart";
  var resource = new Resource(pkg);
  _log.info("dep uri: ${resource.uri}");

  // var inDir = Directory.fromUri(Uri.parse("package:hello_template/"));
  var outDir = Directory(template);

  String filePfx = _resolvePkg("hello_template");

  dartrixPort.send("ready to gen");
  dartrixPort.send(data);
  _log.info("done sending");
}

void printUsage() {
  print("\n\t\tDartrix Template package: hello_templates\n");
  print("Available templates:\n");
  print("\thello");
  print("\tgoodbye\n");
  print("Pass -h to see template doc, e.g. -t hello -h\n");
}

void main(List<String> args, SendPort sport) {
  print("entry: hello_template/dartrix.dart main");
  final fifteenAgo = new DateTime.now().subtract(new Duration(minutes: 15));

  Logger.root.level = Level.ALL;
  Logger.root..onRecord.listen((record) {
      print('${record.loggerName} ${record.level.name}: ${record.message}');
      // ${record.time}:
  });
  // _log.info("entry: hello_template/dartrix.dart:main");
  dartrixPort = sport;

  // _log.info("args: $args");
  // First arg is the template name.
  // _log.info("template: ${args[0]}");

  switch(args[0]) {
    case "hello": generateHello(args, sport); break;
    case "goodbye": generateGoodbye(args, sport); break;
    case null:
    if (args.contains("--help") || args.contains("-h")) {
      printUsage();
    } else {
      print("hello_template: No template specified; canceling.");
    }
    break;
    default:
    print("No template for ${args[0]}; canceling.");
    //TODO: send error to datrix isolate
  }
  // _log.info("exiting main...");
}
